# Class Controller

#### Hierarchy

- Controller

- Defined in src/objectediting/component.js:196

#####
Index

### Properties

active
copyFromActive
defaultStylesWoVertice_
defaultStyles_
deleteFromActive
dirty
dirtyStylesWoVertice_
dirtyStyles_
editableWMSLayer_
feature
featureHasGeom
features_
geomType
geometryChanges_
gettextCatalog_
gmfEditFeature_
gmfObjectEditingQuery_
gmfTreeManager_
interactions_
jstsOL3Parser_
layerNodeId
listenerKeys_
map
modifyToolActivate_
modify_
ngeoFeatureHelper_
ngeoLayerHelper_
ngeoToolActivateMgr_
pending
process
queryableLayerListShown
queryableLayersInfo
scope_
selectedQueryableLayerInfo
sketchFeatures
skipGeometryChange_
state_
timeout_
toolsActive
toolsToolActivate_

### Methods

$onInit
delete
handleDeleteFeature_
handleDestroy_
handleEditFeature_
handleFeatureGeometryChange_
handleGetQueryableLayersInfo_
handleModifyInteractionModifyEnd_
handleSketchFeaturesAdd_
handleWindowBeforeUnload_
initializeInteractions_
initializeStyles_
isStateInsert
refreshWMSLayer_
registerInteractions_
registerTreeCtrl_
resetGeometryChanges_
save
setFeatureStyle_
toggle_
undo
undoAllChanges_
unregisterAllTreeCtrl_
unregisterInteractions_

## Properties

### active

active: boolean

- Defined in src/objectediting/component.js:212

### copyFromActive

copyFromActive: boolean

- Defined in src/objectediting/component.js:288

### defaultStylesWoVertice_

defaultStylesWoVertice_: Object

- Defined in src/objectediting/component.js:374

### defaultStyles_

defaultStyles_: Object

- Defined in src/objectediting/component.js:369

### deleteFromActive

deleteFromActive: boolean

- Defined in src/objectediting/component.js:293

### dirty

dirty: boolean

- Defined in src/objectediting/component.js:396
- Defined in src/objectediting/component.js:486
- Defined in src/objectediting/component.js:488
- Defined in src/objectediting/component.js:525
- Defined in src/objectediting/component.js:747

### dirtyStylesWoVertice_

dirtyStylesWoVertice_: Object

- Defined in src/objectediting/component.js:384

### dirtyStyles_

dirtyStyles_: Object

- Defined in src/objectediting/component.js:379

### editableWMSLayer_

editableWMSLayer_: any

- Defined in src/objectediting/component.js:335
- Defined in src/objectediting/component.js:939
- Defined in src/objectediting/component.js:951

### feature

feature: Feature<Geometry>

- Defined in src/objectediting/component.js:217

### featureHasGeom

featureHasGeom: boolean

- Defined in src/objectediting/component.js:298
- Defined in src/objectediting/component.js:505
- Defined in src/objectediting/component.js:1042

### features_

features_: Collection<Feature<Geometry>>

- Defined in src/objectediting/component.js:406

### geomType

geomType: string

- Defined in src/objectediting/component.js:222

### geometryChanges_

geometryChanges_: Geometry[]

- Defined in src/objectediting/component.js:364

### gettextCatalog_

gettextCatalog_: gettextCatalog

- Defined in src/objectediting/component.js:254

### gmfEditFeature_

gmfEditFeature_: any

- Defined in src/objectediting/component.js:259

### gmfObjectEditingQuery_

gmfObjectEditingQuery_: any

- Defined in src/objectediting/component.js:264

### gmfTreeManager_

gmfTreeManager_: any

- Defined in src/objectediting/component.js:308

### interactions_

interactions_: Collection<Modify>

- Defined in src/objectediting/component.js:411

### jstsOL3Parser_

jstsOL3Parser_: OL3Parser

- Defined in src/objectediting/component.js:340

### layerNodeId

layerNodeId: number

- Defined in src/objectediting/component.js:227

### listenerKeys_

listenerKeys_: EventsKey[]

- Defined in src/objectediting/component.js:401

### map

map: Map

- Defined in src/objectediting/component.js:232

### modifyToolActivate_

modifyToolActivate_: default

- Defined in src/objectediting/component.js:426

### modify_

modify_: Modify

- Defined in src/objectediting/component.js:416

### ngeoFeatureHelper_

ngeoFeatureHelper_: FeatureHelper

- Defined in src/objectediting/component.js:313

### ngeoLayerHelper_

ngeoLayerHelper_: LayerHelper

- Defined in src/objectediting/component.js:303

### ngeoToolActivateMgr_

ngeoToolActivateMgr_: ToolActivateMgr

- Defined in src/objectediting/component.js:318

### pending

pending: boolean

Flag that is toggled while a request is pending.

- Defined in src/objectediting/component.js:391
- Defined in src/objectediting/component.js:526
- Defined in src/objectediting/component.js:551
- Defined in src/objectediting/component.js:615
- Defined in src/objectediting/component.js:643

### process

process: string

- Defined in src/objectediting/component.js:330

### queryableLayerListShown

queryableLayerListShown: boolean

Whether to show or hide the queryable list of layers. It is shown only when a tool requires it, which is managed in the `gmf-objecteditingtools` component.

- Defined in src/objectediting/component.js:283

### queryableLayersInfo

queryableLayersInfo: any[]

- Defined in src/objectediting/component.js:269
- Defined in src/objectediting/component.js:1067

### scope_

scope_: IScope

- Defined in src/objectediting/component.js:244

### selectedQueryableLayerInfo

selectedQueryableLayerInfo: any

- Defined in src/objectediting/component.js:274
- Defined in src/objectediting/component.js:1069

### sketchFeatures

sketchFeatures: Collection<Feature<Geometry>>

- Defined in src/objectediting/component.js:237

### skipGeometryChange_

skipGeometryChange_: boolean

- Defined in src/objectediting/component.js:325
- Defined in src/objectediting/component.js:585
- Defined in src/objectediting/component.js:591
- Defined in src/objectediting/component.js:792
- Defined in src/objectediting/component.js:794

### state_

state_: string

The state of the feature determines whether the next 'save' request should be an 'insert' or 'update' one.

- Defined in src/objectediting/component.js:359
- Defined in src/objectediting/component.js:479
- Defined in src/objectediting/component.js:614
- Defined in src/objectediting/component.js:638
- Defined in src/objectediting/component.js:640

### timeout_

timeout_: ITimeoutService

- Defined in src/objectediting/component.js:249

### toolsActive

toolsActive: boolean

- Defined in src/objectediting/component.js:431
- Defined in src/objectediting/component.js:729

### toolsToolActivate_

toolsToolActivate_: default

- Defined in src/objectediting/component.js:436

## Methods

### $onInit

- $onInit(): void

- Init the controller

  #### Returns void

  - Defined in src/objectediting/component.js:442

### delete

- delete(): void

- Delete the feature after asking for a confirmation.

  #### Returns void

  - Defined in src/objectediting/component.js:520

### handleDeleteFeature_

- handleDeleteFeature_(resp: IHttpResponse<string | Object | Node | Document | ArrayBuffer>): void

- Called after a delete request.

  #### Parameters

  - ##### resp: IHttpResponse<string | Object | Node | Document | ArrayBuffer>

    Ajax response.

  #### Returns void

  - Defined in src/objectediting/component.js:608

### handleDestroy_

- handleDestroy_(): void

- #### Returns void

  - Defined in src/objectediting/component.js:1073

### handleEditFeature_

- handleEditFeature_(resp: IHttpResponse<string | Object | Node | Document | ArrayBuffer>): void

- Called after an 'insert' or 'update' request.

  #### Parameters

  - ##### resp: IHttpResponse<string | Object | Node | Document | ArrayBuffer>

    Ajax response.

  #### Returns void

  - Defined in src/objectediting/component.js:624

### handleFeatureGeometryChange_

- handleFeatureGeometryChange_(): void

- Called when the geometry property of the feature changes, i.e. not when the geometry itself changes but when a new geometry is set to the feature.

  This happens either when resetting the geometry to null, in which case there's nothing to do here. Otherwise, it happens after the combinaison of a sketch geometry with the existing feature geometry. This new geom is pushed in the `geometryChanges_` array.

  #### Returns void

  - Defined in src/objectediting/component.js:1036

### handleGetQueryableLayersInfo_

- handleGetQueryableLayersInfo_(layersInfo: any[]): void

- #### Parameters

  - ##### layersInfo: any[]

    List of queryable layers information, which contains the node and ogcServer.

  #### Returns void

  - Defined in src/objectediting/component.js:1066

### handleModifyInteractionModifyEnd_

- handleModifyInteractionModifyEnd_(evt: Event | BaseEvent): void

- Called after the modification interaction has completed modifying the existing geometry. The new geometry is pushed in the changes array. If the geometry type is `MultiPolygon`, we check if any of the inner geometries intersects with one an other first. Those that does are merged before being pushed to the changes.

  #### Parameters

  - ##### evt: Event | BaseEvent

    Event.

  #### Returns void

  - Defined in src/objectediting/component.js:779

### handleSketchFeaturesAdd_

- handleSketchFeaturesAdd_(evt: Event | BaseEvent): void

- Called when a feature is added to the collection of sketch features. Depending on the current behavior, use the added sketch feature to process the existing geometry.

  #### Parameters

  - ##### evt: Event | BaseEvent

    Event.

  #### Returns void

  - Defined in src/objectediting/component.js:988

### handleWindowBeforeUnload_

- handleWindowBeforeUnload_(e: Event): string

- Called before the window unloads. Show a confirmation message if there are unsaved modifications.

  ### Returns

  Message

  #### Parameters

  - ##### e: Event

    Event.

  #### Returns string

  - Defined in src/objectediting/component.js:970

### initializeInteractions_

- initializeInteractions_(): void

- Initialize interactions by setting them inactive and decorating them

  #### Returns void

  - Defined in src/objectediting/component.js:651

### initializeStyles_

- initializeStyles_(styles: Object, color: Color, opt_incVertice?: boolean): void

- #### Parameters

  - ##### styles: Object

    Hash of style.

  - ##### color: Color

    Color.

  - ##### `Optional` opt_incVertice: boolean

    Whether to include vertice or not.

  #### Returns void

  - Defined in src/objectediting/component.js:810

### isStateInsert

- isStateInsert(): boolean

- ### Returns

  Whether the state is INSERT or not.

  #### Returns boolean

  - Defined in src/objectediting/component.js:597

### refreshWMSLayer_

- refreshWMSLayer_(): void

- Refresh the WMS layer, if set.

  #### Returns void

  - Defined in src/objectediting/component.js:957

### registerInteractions_

- registerInteractions_(): void

- Register interactions by adding them to the map

  #### Returns void

  - Defined in src/objectediting/component.js:661

### registerTreeCtrl_

- registerTreeCtrl_(treeCtrl: LayertreeController): void

- Registers a newly added Layertree controller 'leaf', i.e. groups are excluded.

  If the Layertree controller node id is equal to the `layerNodeId` configured with this component, then find the WMS layer associated with it for for refresh purpose.

  #### Parameters

  - ##### treeCtrl: LayertreeController

    Layertree controller to register

  #### Returns void

  - Defined in src/objectediting/component.js:927

### resetGeometryChanges_

- resetGeometryChanges_(): void

- Reset the array of geometry changes. If there are more than one changes, reset them entirely. Then, if there's no changes, clone the current geometry as the first entry. One entry means that there's no changes.

  #### Returns void

  - Defined in src/objectediting/component.js:756

### save

- save(): void

- Save the current modifications.

  #### Returns void

  - Defined in src/objectediting/component.js:543

### setFeatureStyle_

- setFeatureStyle_(): void

- Set the style of the feature depending on:

  - the geometry type
  - the dirty state of the component
  - whether the modify control is active or not

  #### Returns void

  - Defined in src/objectediting/component.js:890

### toggle_

- toggle_(active: boolean): void

- Activate or deactivate this component.

  #### Parameters

  - ##### active: boolean

    Whether to activate this component or not.

  #### Returns void

  - Defined in src/objectediting/component.js:687

### undo

- undo(): void

- Undo the latest modifications.

  #### Returns void

  - Defined in src/objectediting/component.js:576

### undoAllChanges_

- undoAllChanges_(): void

- Undo all current changes.

  #### Returns void

  - Defined in src/objectediting/component.js:736

### unregisterAllTreeCtrl_

- unregisterAllTreeCtrl_(): void

- Unregisters all currently registered Layertree controllers.

  Unset the WMS layer associated with the `layerNodeId` configured with this component.

  #### Returns void

  - Defined in src/objectediting/component.js:950

### unregisterInteractions_

- unregisterInteractions_(): void

- Unregister interactions, i.e. remove them from the map

  #### Returns void

  - Defined in src/objectediting/component.js:673

Generated using TypeDoc